## votca-tools 1.2.3

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.6)

project(votca-tools)

set(PROJECT_VERSION "1.2.3")
string(REGEX REPLACE "^[1-9]+\\.([1-9]+).*$" "\\1" SOVERSION "${PROJECT_VERSION}")
if (NOT ${SOVERSION} MATCHES "[1-9]+")
  message(FATAL_ERROR "Could not determind SOVERSION from ${PROJECT_VERSION}")
endif (NOT ${SOVERSION} MATCHES "[1-9]+")

# Cmake modules/macros are in a subdirectory to keep this file cleaner
set(CMAKE_MODULE_PATH ${CMAKE_SOURCE_DIR}/CMakeModules)

if(NOT CMAKE_BUILD_TYPE)
  #release comes with -O3 by default
  set(CMAKE_BUILD_TYPE Release CACHE STRING "Choose the type of build, options are: None Debug Release RelWithDebInfo MinSizeRel." FORCE)
endif(NOT CMAKE_BUILD_TYPE)

enable_language(CXX)


######################################################################
# compiler tests
# these need ot be done early (before further tests).
#####################################################################

include(CheckCXXCompilerFlag)

########################################################################
# User input options                                                   #
########################################################################
option(BUILD_SHARED_LIBS "Build shared libs" ON)
if (NOT DEFINED LIB)
  set(LIB "lib")
endif(NOT DEFINED LIB)
if (NOT DEFINED MAN)
  set(MAN "share/man")
endif(NOT DEFINED MAN)
if (NOT DEFINED DATA)
  set(DATA "share/votca")
endif(NOT DEFINED DATA)


#this has to be the first include directive
include_directories(${CMAKE_SOURCE_DIR}/include)

########################################################################
#Find external packages
########################################################################
find_package(Mercurial)
find_package(Threads REQUIRED)
set(THREAD_LIBRARIES ${CMAKE_THREAD_LIBS_INIT})
find_package(TXT2TAGS)

########################################################################
# Basic system tests (standard libraries, headers, functions, types)   #
########################################################################
include(CheckIncludeFile)
foreach(HEADER assert.h math.h stdio.h stdlib.h string.h)
  check_include_file(${HEADER} FOUND_${HEADER})
  if(NOT FOUND_${HEADER})
    message(FATAL_ERROR "Could not find needed header - ${HEADER}")
  endif(NOT FOUND_${HEADER})
endforeach(HEADER)

include(CheckIncludeFileCXX)
foreach(HEADER cmath fstream functional iostream limits list map ostream sstream stack stdexcept string vector)
  check_include_file_cxx(${HEADER} FOUND_${HEADER})
  if(NOT FOUND_${HEADER})
    message(FATAL_ERROR "Could not find needed header - ${HEADER}")
  endif(NOT FOUND_${HEADER})
endforeach(HEADER)

set(MATH_LIBRARIES "m" CACHE STRING "math library")
mark_as_advanced( MATH_LIBRARIES )
include(CheckLibraryExists)
foreach(FUNC sqrt)
  check_library_exists(${MATH_LIBRARIES} ${FUNC} "" FOUND_${FUNC}_${MATH_LIBRARIES})
  if(NOT FOUND_${FUNC}_${MATH_LIBRARIES})
    message(FATAL_ERROR "Could not find needed math function - ${FUNC}")
  endif(NOT FOUND_${FUNC}_${MATH_LIBRARIES})
endforeach(FUNC)

######################################
# Include the following subdirectory # 
######################################
add_subdirectory(src)
add_subdirectory(include/votca/tools)
add_subdirectory(scripts)
add_subdirectory(share/man)
add_subdirectory(share/doc)

configure_file(${CMAKE_MODULE_PATH}/cmake_uninstall.cmake.in ${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake IMMEDIATE @ONLY)
add_custom_target(uninstall COMMAND ${CMAKE_COMMAND} -P ${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake)

=== debian/changelog ===
votca-tools (1.2.3-1) unstable; urgency=low

  [ Christoph Junghans ]
  * Initial release (Closes: #621874)

 -- Michael Banck <mbanck@debian.org>  Wed, 29 Jan 2014 20:20:27 +0100

=== debian/control ===
Source: votca-tools
Section: libs
Priority: optional
Maintainer: Debichem Team <debichem-devel@lists.alioth.debian.org>
Uploaders: Christoph Junghans <junghans@votca.org>, Michael Banck <mbanck@debian.org>
Build-Depends: debhelper (>= 9.0.0), cmake, libfftw3-dev, libgsl0-dev, txt2tags, libboost-program-options-dev, libexpat1-dev, libsqlite3-dev, pkg-config
Standards-Version: 3.9.5
Homepage: http://www.votca.org

Package: libvotca-tools-dev
Section: libdevel
Architecture: any
Depends: libvotca-tools2 (= ${binary:Version}), ${misc:Depends}
Description: VOTCA's tools library, development kit
 VOTCA is a software package which focuses on the analysis of molecular
 dynamics data, the development of systematic coarse-graining techniques as
 well as methods used for simulating microscopic charge transport in
 disordered semiconductors.
 .
 VOTCA's tools library provides functions shared between all VOTCA packages.
 .
 This package contains header files and pkg-config files.

Package: libvotca-tools2
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: VOTCA's tools library
 VOTCA is a software package which focuses on the analysis of molecular
 dynamics data, the development of systematic coarse-graining techniques as
 well as methods used for simulating microscopic charge transport in
 disordered semiconductors.
 .
 VOTCA's tools library provides functions shared between all VOTCA packages.

=== debian/watch ===
version=3
http://code.google.com/p/votca/downloads/list .*/votca-tools-(\d\S*)\.(?:zip|tgz|tbz|txz|(?:tar\.(?:gz|bz2|xz)))

## votca-tools 1.2.4

=== CMakeLists.txt ===
--- 
+++ 
@@ -2,7 +2,7 @@
 
 project(votca-tools)
 
-set(PROJECT_VERSION "1.2.3")
+set(PROJECT_VERSION "1.2.4")
 string(REGEX REPLACE "^[1-9]+\\.([1-9]+).*$" "\\1" SOVERSION "${PROJECT_VERSION}")
 if (NOT ${SOVERSION} MATCHES "[1-9]+")
   message(FATAL_ERROR "Could not determind SOVERSION from ${PROJECT_VERSION}")

=== scripts/CMakeLists.txt ===
option(WITH_RC_FILES "Install votca rc files, no need when installing under /usr" ON)
if (WITH_RC_FILES)
  if(APPLE)
    set(LD_LIBRARY_PATH "DYLD_LIBRARY_PATH")
  else(APPLE)
    include(CheckCSourceCompiles)
    check_c_source_compiles(
      "int main(void) {
      #ifndef _AIX
      #error
      #endif
      return 0;
      }" HAVE_AIX)
    if(HAVE_AIX)
      set(LD_LIBRARY_PATH "LIBPATH")
    else(HAVE_AIX)
      set(LD_LIBRARY_PATH "LD_LIBRARY_PATH")
    endif(HAVE_AIX)
  endif(APPLE)
  configure_file(VOTCARC.csh.in ${CMAKE_CURRENT_BINARY_DIR}/VOTCARC.csh @ONLY)
  configure_file(VOTCARC.bash.in ${CMAKE_CURRENT_BINARY_DIR}/VOTCARC.bash @ONLY)
  install(PROGRAMS ${CMAKE_CURRENT_BINARY_DIR}/VOTCARC.csh
    ${CMAKE_CURRENT_BINARY_DIR}/VOTCARC.bash DESTINATION bin)
endif (WITH_RC_FILES)

=== src/CMakeLists.txt ===
option(EXTERNAL_BOOST "Use external boost" ON)
if (EXTERNAL_BOOST)
  find_package(Boost 1.39.0 COMPONENTS program_options )
  if(NOT Boost_FOUND)
    message(FATAL_ERROR "Boost not found,  make sure you have also installed boost and it's dev package or use our internal replacement set -DEXTERNAL_BOOST=OFF")
  endif(NOT Boost_FOUND)
  include_directories(${Boost_INCLUDE_DIRS})
  set (BOOST_LIBRARIES ${Boost_PROGRAM_OPTIONS_LIBRARY})
  set (BOOST_PKG)
  set (BOOST_CFLAGS_PKG "-I${Boost_INCLUDE_DIRS}")
  string(REGEX REPLACE "^(.*)/lib([^/]*)\\.[^.]*$" "-L\\1 -l\\2" BOOST_LIBS_PKG ${BOOST_LIBRARIES})
else(EXTERNAL_BOOST)
  include_directories(${CMAKE_SOURCE_DIR}/src/libboost)
  add_subdirectory(libboost)
  set (BOOST_LIBRARIES votca_boost)
  set (BOOST_PKG "libvotca_boost")
  set (BOOST_LIBS_PKG)
  set (BOOST_CFLAGS_PKG)
endif(EXTERNAL_BOOST)
add_subdirectory(libtools)

=== share/man/CMakeLists.txt ===
if (TXT2TAGS_FOUND)
  add_custom_command(OUTPUT votca-tools.man 
    COMMAND ${TXT2TAGS_EXECUTABLE} -q -t man -i ${CMAKE_CURRENT_SOURCE_DIR}/votca-tools.t2t -o votca-tools.man
    COMMENT "Building votca_tools manpage")
  add_custom_target(manpages DEPENDS votca-tools.man)
  add_dependencies(votca_tools manpages)
  install(FILES ${CMAKE_CURRENT_BINARY_DIR}/votca-tools.man DESTINATION ${MAN}/man7 RENAME votca-tools.7)
endif (TXT2TAGS_FOUND)

=== src/libboost/CMakeLists.txt ===
file(GLOB_RECURSE BOOST_SOURCES libs/*.cpp)
file(GLOB_RECURSE NOT_BOOST_SOURCES libs/detail/utf8_codecvt_facet.cpp)
list(REMOVE_ITEM BOOST_SOURCES ${NOT_BOOST_SOURCES})

add_library(votca_boost ${BOOST_SOURCES})
install(TARGETS votca_boost LIBRARY DESTINATION ${LIB} ARCHIVE DESTINATION ${LIB})

configure_file(libvotca_boost.pc.in ${CMAKE_CURRENT_BINARY_DIR}/libvotca_boost.pc @ONLY)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/libvotca_boost.pc DESTINATION ${LIB}/pkgconfig)

install(DIRECTORY boost DESTINATION include/votca)

=== src/libtools/CMakeLists.txt ===
find_package(EXPAT)
if(NOT EXPAT_FOUND)
  message(FATAL_ERROR "EXPAT not found,  make sure you have also installed the expat and it's dev package")
endif(NOT EXPAT_FOUND)
include_directories(${EXPAT_INCLUDE_DIR})
set (EXPAT_CFLAGS_PKG "-I${EXPAT_INCLUDE_DIRS}")
string(REGEX REPLACE "^(.*)/lib([^/]*)\\.[^.]*$" "-L\\1 -l\\2" EXPAT_LIBS_PKG ${EXPAT_LIBRARY})

option(WITH_FFTW "Use FFTW3, disabling leads to reduced functionality!" ON)
if (WITH_FFTW)
  find_package(FFTW3)
  if(NOT FFTW3_FOUND)
    message(FATAL_ERROR "FFTW3 not found,  make sure you have also installed the fftw3 and it's dev package")
  endif(NOT FFTW3_FOUND)
  include_directories(${FFTW3_INCLUDE_DIRS})
  set(FFTW3_PKG "fftw3")
else(WITH_FFTW)
  #used in votca_config.h
  set(NOFFTW TRUE)
  set(FFTW3_PKG)
endif(WITH_FFTW)

option(WITH_GSL "Use GSL, disabling leads to reduced functionality!" ON)
if (WITH_GSL)
  find_package(GSL)
  if(NOT GSL_FOUND)
    message(FATAL_ERROR "GSL not found,  make sure you have also installed the gsl and it's dev package")
  endif(NOT GSL_FOUND)
  include_directories(${GSL_INCLUDE_DIRS})
  set(GSL_PKG "gsl")
else(WITH_GSL)
  #used in votca_config.h
  set(NOGSL TRUE)
  set(GSL_PKG)
endif(WITH_GSL)

file(GLOB_RECURSE VOTCA_SOURCES *.cc)
file(GLOB NOT_VOTCA_SOURCES version_nb.cc linktest.cc)
file(GLOB_RECURSE VOTCA_SQL_SOURCES database.cc statement.cc)
list(REMOVE_ITEM VOTCA_SOURCES ${NOT_VOTCA_SOURCES} ${VOTCA_SQL_SOURCES})

option(WITH_SQLITE3 "Use SQLite3, at this point only needed for charge transport parts!" ON)
if (WITH_SQLITE3)
  find_package(SQLITE3)
  if(NOT SQLITE3_FOUND)
    message(FATAL_ERROR "SQLITE3 not found,  make sure you have also installed the sqlite3 and it's dev package, at this point sqlite3 is only needed for charge transport parts of VOTCA, so you can just switch it off using -DWITH_SQLITE3=OFF in case you do not need it.")
  endif(NOT SQLITE3_FOUND)
  include_directories(${SQLITE3_INCLUDE_DIRS})
  set(SQLITE3_PKG "sqlite3")
else(WITH_SQLITE3)
  set(SQLITE3_PKG)
  set(VOTCA_SQL_SOURCES)
endif(WITH_SQLITE3)

configure_file(votca_config.h.in ${CMAKE_CURRENT_BINARY_DIR}/votca_config.h)
include_directories(${CMAKE_CURRENT_BINARY_DIR})

add_custom_target(hgversion COMMAND ${CMAKE_COMMAND} -DTOP_SOURCE_DIR="${CMAKE_SOURCE_DIR}" -P ${CMAKE_MODULE_PATH}/hgversion.cmake)
set_property(DIRECTORY APPEND PROPERTY ADDITIONAL_MAKE_CLEAN_FILES hgversion.h)

add_library(votca_tools ${VOTCA_SOURCES} ${VOTCA_SQL_SOURCES})
add_dependencies(votca_tools hgversion)
set_target_properties(votca_tools PROPERTIES SOVERSION ${SOVERSION})
target_link_libraries(votca_tools ${BOOST_LIBRARIES} ${GSL_LIBRARIES} ${SQLITE3_LIBRARIES}
  ${FFTW3_LIBRARIES} ${EXPAT_LIBRARIES} ${THREAD_LIBRARIES} ${MATH_LIBRARIES})
install(TARGETS votca_tools LIBRARY DESTINATION ${LIB} ARCHIVE DESTINATION ${LIB})

configure_file(libvotca_tools.pc.in ${CMAKE_CURRENT_BINARY_DIR}/libvotca_tools.pc @ONLY)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/libvotca_tools.pc DESTINATION ${LIB}/pkgconfig)

add_executable(linktest linktest.cc)
target_link_libraries(linktest votca_tools)

=== include/votca/tools/CMakeLists.txt ===
file(GLOB_RECURSE VOTCA_HEADERS *.h)
if (NOT WITH_SQLITE3)
  file(GLOB_RECURSE NOT_VOTCA_HEADERS database.h statement.h)
  list(REMOVE_ITEM VOTCA_HEADERS ${NOT_VOTCA_HEADERS})
endif(NOT WITH_SQLITE3)
install(FILES ${VOTCA_HEADERS} DESTINATION include/votca/tools)

=== debian/changelog ===
votca-tools (1.2.4-1.1) unstable; urgency=medium

  * Non-maintainer upload.

  [ Bas Couwenberg ]
  * Update build dependencies for GSL 2, change libgsl0-dev to libgsl-dev.
    Closes: #807229

  [ Mattia Rizzolo ]
  * move debian/upstream to debian/upstream/metadata

 -- Mattia Rizzolo <mattia@debian.org>  Tue, 26 Jan 2016 10:38:47 +0000

votca-tools (1.2.4-1) unstable; urgency=low

  * Version bump 
  * Add Vcs-Browser and Vcs-Svn fields to debian/control

 -- Christoph Junghans <junghans@votca.org>  Wed, 03 Sep 2014 15:39:12 -0600

=== debian/control ===
--- 
+++ 
@@ -3,9 +3,11 @@
 Priority: optional
 Maintainer: Debichem Team <debichem-devel@lists.alioth.debian.org>
 Uploaders: Christoph Junghans <junghans@votca.org>, Michael Banck <mbanck@debian.org>
-Build-Depends: debhelper (>= 9.0.0), cmake, libfftw3-dev, libgsl0-dev, txt2tags, libboost-program-options-dev, libexpat1-dev, libsqlite3-dev, pkg-config
+Build-Depends: debhelper (>= 9.0.0), cmake, libfftw3-dev, libgsl-dev, txt2tags, libboost-program-options-dev, libexpat1-dev, libsqlite3-dev, pkg-config
 Standards-Version: 3.9.5
 Homepage: http://www.votca.org
+Vcs-Browser: http://anonscm.debian.org/viewvc/debichem/unstable/votca-tools/
+Vcs-Svn: svn://anonscm.debian.org/debichem/unstable/votca-tools/
 
 Package: libvotca-tools-dev
 Section: libdevel

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

override_dh_auto_configure:
	dh_auto_configure -- -DLIB=lib/$(DEB_HOST_MULTIARCH)

%:
	dh $@

=== debian/watch ===
version=3
http://downloads.votca.googlecode.com/hg/votca-tools-([.0-9]+)_pristine\.(?:zip|tgz|tbz|txz|(?:tar\.(?:gz|bz2|xz)))

## votca-tools 1.3.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -2,19 +2,19 @@
 
 project(votca-tools)
 
-set(PROJECT_VERSION "1.2.4")
+set(PROJECT_VERSION "1.3")
 string(REGEX REPLACE "^[1-9]+\\.([1-9]+).*$" "\\1" SOVERSION "${PROJECT_VERSION}")
 if (NOT ${SOVERSION} MATCHES "[1-9]+")
   message(FATAL_ERROR "Could not determind SOVERSION from ${PROJECT_VERSION}")
 endif (NOT ${SOVERSION} MATCHES "[1-9]+")
 
 # Cmake modules/macros are in a subdirectory to keep this file cleaner
-set(CMAKE_MODULE_PATH ${CMAKE_SOURCE_DIR}/CMakeModules)
+set(CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/CMakeModules)
 
-if(NOT CMAKE_BUILD_TYPE)
+if(NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CXX_FLAGS)
   #release comes with -O3 by default
   set(CMAKE_BUILD_TYPE Release CACHE STRING "Choose the type of build, options are: None Debug Release RelWithDebInfo MinSizeRel." FORCE)
-endif(NOT CMAKE_BUILD_TYPE)
+endif(NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CXX_FLAGS)
 
 enable_language(CXX)
 
@@ -40,17 +40,31 @@
   set(DATA "share/votca")
 endif(NOT DEFINED DATA)
 
-
 #this has to be the first include directive
-include_directories(${CMAKE_SOURCE_DIR}/include)
+include_directories(${CMAKE_CURRENT_SOURCE_DIR}/include)
 
 ########################################################################
 #Find external packages
 ########################################################################
-find_package(Mercurial)
+if(IS_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/.git)
+  find_package(Git)
+endif(IS_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/.git)
+
 find_package(Threads REQUIRED)
 set(THREAD_LIBRARIES ${CMAKE_THREAD_LIBS_INIT})
-find_package(TXT2TAGS)
+
+find_package(Boost 1.39.0 REQUIRED COMPONENTS program_options filesystem system )
+include_directories(${Boost_INCLUDE_DIRS})
+set (BOOST_CFLAGS_PKG "-I${Boost_INCLUDE_DIRS}")
+set(BOOST_LIBS_PKG "-L${Boost_LIBRARY_DIRS}")
+foreach(_blib ${Boost_LIBRARIES})
+  string(REGEX REPLACE ".*/lib([^/]*)\\.[^.]*$" "-l\\1" _blib ${_blib})
+  set(BOOST_LIBS_PKG "${BOOST_LIBS_PKG} ${_blib}")
+endforeach(_blib)
+
+option(BUILD_MANPAGES "Build manpages (might lead to problem on system without rpath" ON)
+#define this target here, so that individual man pages can append to it.
+add_custom_target(manpages ALL)
 
 ########################################################################
 # Basic system tests (standard libraries, headers, functions, types)   #

=== src/libtools/CMakeLists.txt ===
find_package(EXPAT)
if(NOT EXPAT_FOUND)
  message(FATAL_ERROR "EXPAT not found,  make sure you have also installed the expat and it's dev package")
endif(NOT EXPAT_FOUND)
include_directories(${EXPAT_INCLUDE_DIR})
set (EXPAT_CFLAGS_PKG "-I${EXPAT_INCLUDE_DIRS}")
string(REGEX REPLACE "^(.*)/lib([^/]*)\\.[^.]*$" "-L\\1 -l\\2" EXPAT_LIBS_PKG ${EXPAT_LIBRARY})

option(WITH_FFTW "Use FFTW3, disabling leads to reduced functionality!" ON)
if (WITH_FFTW)
  find_package(FFTW3)
  if(NOT FFTW3_FOUND)
    message(FATAL_ERROR "FFTW3 not found,  make sure you have also installed the fftw3 and it's dev package (it can be disable with -DWITH_FFTW=OFF)")
  endif(NOT FFTW3_FOUND)
  include_directories(${FFTW3_INCLUDE_DIRS})
  set(FFTW3_PKG "fftw3")
else(WITH_FFTW)
  #used in votca_config.h
  set(NOFFTW TRUE)
  set(FFTW3_PKG)
endif(WITH_FFTW)

option(WITH_GSL "Use GSL, disabling leads to reduced functionality!" ON)
if (WITH_GSL)
  find_package(GSL)
endif(WITH_GSL)

option(WITH_MKL "Checking if MKL is installed in order to improve UBLAS performance" ON)
if (WITH_MKL)
  find_package(MKL)
  if(NOT MKL_FOUND AND CMAKE_CXX_COMPILER_ID STREQUAL "Intel")
    #TODO: try to append -mkl to cflags
  endif(NOT MKL_FOUND AND CMAKE_CXX_COMPILER_ID STREQUAL "Intel")
endif(WITH_MKL)

#option(WITH_EIGEN "Checking if Eigen3 is installed in order to improve performance" ON)
#if (WITH_EIGEN)
#  find_package(Eigen) #it looks for eigen3
#endif (WITH_EIGEN)

#we can only use of of these
set(GSL_PKG)
set(EIGEN)
set(EIGEN_PKG)
#it seems there is a problem with gcc-4.8 and mkl
# let force icc for now
if(NOT WITH_MKL AND NOT WITH_GSL)
  #explicitly disabled
  file(GLOB VOTCA_LINALG_SOURCES linalg/dummy/*.cc)
else()
  if (MKL_FOUND AND CMAKE_CXX_COMPILER_ID STREQUAL "Intel")
    include_directories(${MKL_INCLUDE_DIRS})
    file(GLOB VOTCA_LINALG_SOURCES linalg/mkl/*.cc)
    set(LINALG_LIBRARIES ${MKL_LIBRARIES})
  elseif(GSL_FOUND)
    include_directories(${GSL_INCLUDE_DIRS})
    set(GSL_PKG "gsl") #used in libvotca_csg.pc
    file(GLOB VOTCA_LINALG_SOURCES linalg/gsl/*.cc)
    set(LINALG_LIBRARIES ${GSL_LIBRARIES})
  #elseif (EIGEN_FOUND)
  #  set(EIGEN TRUE) #used in votca_config.h
  #  set(EIGEN_PKG "eigen3") #used in libvotca_csg.pc
  #  include_directories(${EIGEN_INCLUDE_DIRS})
  #  file(GLOB VOTCA_LINALG_SOURCES linalg/eigen/*.cc)
  #  set(LINALG_LIBRARIES ${EIGEN_LIBRARIES})
  else()
    message(FATAL_ERROR "NO gsl nor mkl found")
  endif()
endif()

file(GLOB VOTCA_SOURCES *.cc)
file(GLOB NOT_VOTCA_SOURCES version_nb.cc)
file(GLOB_RECURSE VOTCA_SQL_SOURCES database.cc statement.cc)
list(REMOVE_ITEM VOTCA_SOURCES ${NOT_VOTCA_SOURCES} ${VOTCA_SQL_SOURCES})

option(WITH_SQLITE3 "Use SQLite3, at this point only needed for charge transport parts!" ON)
if (WITH_SQLITE3)
  find_package(SQLITE3)
  if(NOT SQLITE3_FOUND)
    message(FATAL_ERROR "SQLITE3 not found,  make sure you have also installed the sqlite3 and it's dev package, at this point sqlite3 is only needed for charge transport parts of VOTCA, so you can just switch it off using -DWITH_SQLITE3=OFF in case you do not need it.")
  endif(NOT SQLITE3_FOUND)
  include_directories(${SQLITE3_INCLUDE_DIRS})
  set(SQLITE3_PKG "sqlite3")
else(WITH_SQLITE3)
  set(SQLITE3_PKG)
  set(VOTCA_SQL_SOURCES)
endif(WITH_SQLITE3)

configure_file(votca_config.h.in ${CMAKE_CURRENT_BINARY_DIR}/votca_config.h)

#for gitversion.h and votca_config.h
include_directories(${CMAKE_CURRENT_BINARY_DIR})

add_custom_target(gitversion COMMAND ${CMAKE_COMMAND}
  -DTOP_SOURCE_DIR="${CMAKE_SOURCE_DIR}"
  -DGIT_EXECUTABLE="${GIT_EXECUTABLE}"
  -DMERCURIAL_EXECUTABLE="${MERCURIAL_EXECUTABLE}"
  -P ${CMAKE_MODULE_PATH}/gitversion.cmake)
set_property(DIRECTORY APPEND PROPERTY ADDITIONAL_MAKE_CLEAN_FILES gitversion.h)

add_library(votca_tools ${VOTCA_SOURCES} ${VOTCA_SQL_SOURCES} ${VOTCA_LINALG_SOURCES})
add_dependencies(votca_tools gitversion)
set_target_properties(votca_tools PROPERTIES SOVERSION ${SOVERSION})
target_link_libraries(votca_tools ${Boost_LIBRARIES} ${LINALG_LIBRARIES} ${SQLITE3_LIBRARIES}
  ${FFTW3_LIBRARIES} ${EXPAT_LIBRARIES} ${THREAD_LIBRARIES} ${MATH_LIBRARIES})
install(TARGETS votca_tools LIBRARY DESTINATION ${LIB} ARCHIVE DESTINATION ${LIB})

configure_file(libvotca_tools.pc.in ${CMAKE_CURRENT_BINARY_DIR}/libvotca_tools.pc @ONLY)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/libvotca_tools.pc DESTINATION ${LIB}/pkgconfig)

=== debian/changelog ===
votca-tools (1.3.0-2build2) zesty; urgency=high

  * No change rebuild against boost1.62.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Tue, 01 Nov 2016 16:53:32 +0000

votca-tools (1.3.0-2build1) yakkety; urgency=medium

  * No-change rebuild for boost soname change.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 04 Aug 2016 08:33:43 +0000

votca-tools (1.3.0-2) unstable; urgency=medium

  * debian/control (libvotca-tools3): Added Breaks and Replaces on
    libvotca-tools2 (Closes: #816561).

 -- Michael Banck <mbanck@debian.org>  Thu, 03 Mar 2016 01:04:19 +0100

votca-tools (1.3.0-1) unstable; urgency=medium

  * New upstream release.

  [ Daniel Leidert ]
  * Fixed some lintian reported issues.
  * debian/copyright: Replaced references to code.google.com.
  * debian/watch: Updated after project moved to github.
  * debian/upstream: Renamed to debian/upstream/metadata. Replaced references
    to code.google.com accordingly.

  [ Michael Banck ]
  * debian/control (libvotca-tools2): Renamed to ...
  * debian/control (libvotca-tools3): ... this (Closes: #797293).
  * debian/libvotca-tools2.install: Renamed to ...
  * debian/libvotca-tools3.install: ... this.
  * Acknowledge NMU.
  * debian/control (Build-Depends): Added libboost-filesystem-dev and
    libboost-system-dev.
	
 -- Michael Banck <mbanck@debian.org>  Wed, 24 Feb 2016 22:42:00 +0100

=== debian/control ===
Source: votca-tools
Section: libs
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debichem Team <debichem-devel@lists.alioth.debian.org>
Uploaders: Christoph Junghans <junghans@votca.org>,
           Michael Banck <mbanck@debian.org>
Build-Depends: cmake,
               debhelper (>= 9.0.0),
               libboost-filesystem-dev,
               libboost-program-options-dev,
               libboost-system-dev,
               libexpat1-dev,
               libfftw3-dev,
               libgsl-dev,
               libsqlite3-dev,
               pkg-config,
               txt2tags
Standards-Version: 3.9.5
Homepage: http://www.votca.org
Vcs-Browser: http://anonscm.debian.org/viewvc/debichem/unstable/votca-tools/
Vcs-Svn: svn://anonscm.debian.org/debichem/unstable/votca-tools/

Package: libvotca-tools-dev
Section: libdevel
Architecture: any
Depends: libvotca-tools3 (= ${binary:Version}), ${misc:Depends}
Description: VOTCA's tools library, development kit
 VOTCA is a software package which focuses on the analysis of molecular
 dynamics data, the development of systematic coarse-graining techniques as
 well as methods used for simulating microscopic charge transport in
 disordered semiconductors.
 .
 VOTCA's tools library provides functions shared between all VOTCA packages.
 .
 This package contains header files and pkg-config files.

Package: libvotca-tools3
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Breaks: libvotca-tools2 (<< 1.3)
Replaces: libvotca-tools2 (<< 1.3)
Description: VOTCA's tools library
 VOTCA is a software package which focuses on the analysis of molecular
 dynamics data, the development of systematic coarse-graining techniques as
 well as methods used for simulating microscopic charge transport in
 disordered semiconductors.
 .
 VOTCA's tools library provides functions shared between all VOTCA packages.

## votca-tools 1.4.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,8 +1,8 @@
-cmake_minimum_required(VERSION 2.6)
+cmake_minimum_required(VERSION 2.8.3)
 
 project(votca-tools)
 
-set(PROJECT_VERSION "1.3")
+set(PROJECT_VERSION "1.4.1")
 string(REGEX REPLACE "^[1-9]+\\.([1-9]+).*$" "\\1" SOVERSION "${PROJECT_VERSION}")
 if (NOT ${SOVERSION} MATCHES "[1-9]+")
   message(FATAL_ERROR "Could not determind SOVERSION from ${PROJECT_VERSION}")
@@ -42,6 +42,8 @@
 
 #this has to be the first include directive
 include_directories(${CMAKE_CURRENT_SOURCE_DIR}/include)
+#for votca_config.h
+include_directories(${CMAKE_CURRENT_BINARY_DIR}/include)
 
 ########################################################################
 #Find external packages
@@ -65,6 +67,57 @@
 option(BUILD_MANPAGES "Build manpages (might lead to problem on system without rpath" ON)
 #define this target here, so that individual man pages can append to it.
 add_custom_target(manpages ALL)
+
+########################################################################
+# Checks what linear algebra packages are installed                    #
+########################################################################
+
+find_package(GSL)
+find_package(MKL)
+
+if (MKL_FOUND)
+  message("-- MKL found, overloading uBLAS prod()")
+  set(MKL TRUE) #used in votca_config.h
+elseif(GSL_FOUND)
+  message("-- GSL found, overloading uBLAS prod()")
+  include_directories(${GSL_INCLUDE_DIRS})
+  set(GSL_PKG "gsl")
+  set(GSL TRUE) #used in votca_config.h
+endif()
+
+if(MKL_FOUND)
+  set(MKL_URL "http://software.intel.com/sites/default/files/managed/76/8c/intel-mkl-and-boost-example.zip")
+  set(MKL_MD5 b957ee63a2167ad21b650b47726cd55c )
+  set(MKL_FILE "intel-mkl-and-boost-example.zip")
+  
+  include(ExternalProject)
+  ExternalProject_add(intel
+          PREFIX intel
+          URL "${MKL_URL}" URL_MD5 "${MKL_MD5}"
+          CONFIGURE_COMMAND ""
+          BUILD_COMMAND ""
+          INSTALL_COMMAND ""
+          )
+  set(MKL_BOOST_INCLUDE_DIR "${CMAKE_CURRENT_BINARY_DIR}/intel/src/intel/MKL_and_boost_example/headers")
+  set_property(DIRECTORY APPEND PROPERTY ADDITIONAL_MAKE_CLEAN_FILES "${CMAKE_CURRENT_BINARY_DIR}/intel/src/intel")
+  include_directories(${MKL_BOOST_INCLUDE_DIR})
+  set(MKL_HEADERS "${MKL_BOOST_INCLUDE_DIR}/mkl_boost_ublas_matrix_prod.hpp" "${MKL_BOOST_INCLUDE_DIR}/mkl_boost_ublas_gemm.hpp"  )
+  install(FILES ${MKL_HEADERS} DESTINATION include/votca/tools)
+endif(MKL_FOUND)
+
+option(WITH_FFTW "Use FFTW3, disabling leads to reduced functionality!" ON)
+if (WITH_FFTW)
+  find_package(FFTW3)
+  if(NOT FFTW3_FOUND)
+    message(FATAL_ERROR "FFTW3 not found,  make sure you have also installed the fftw3 and it's dev package (it can be disable with -DWITH_FFTW=OFF)")
+  endif(NOT FFTW3_FOUND)
+  include_directories(${FFTW3_INCLUDE_DIRS})
+  set(FFTW3_PKG "fftw3")
+else(WITH_FFTW)
+  #used in votca_config.h
+  set(NOFFTW TRUE)
+  set(FFTW3_PKG)
+endif(WITH_FFTW)
 
 ########################################################################
 # Basic system tests (standard libraries, headers, functions, types)   #
@@ -106,3 +159,6 @@
 
 configure_file(${CMAKE_MODULE_PATH}/cmake_uninstall.cmake.in ${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake IMMEDIATE @ONLY)
 add_custom_target(uninstall COMMAND ${CMAKE_COMMAND} -P ${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake)
+
+include(FeatureSummary)
+feature_summary(INCLUDE_QUIET_PACKAGES WHAT ALL)

=== src/CMakeLists.txt ===
add_subdirectory(libtools)
add_subdirectory(tools)

=== share/man/CMakeLists.txt ===
if (BUILD_MANPAGES)
  add_custom_target(votca_tools_manpages DEPENDS votca-tools.man)
  add_dependencies(manpages votca_tools_manpages)
  install(FILES votca-tools.man DESTINATION ${MAN}/man7 RENAME votca-tools.7)
endif (BUILD_MANPAGES)

=== src/libtools/CMakeLists.txt ===
find_package(EXPAT)
if(NOT EXPAT_FOUND)
  message(FATAL_ERROR "EXPAT not found,  make sure you have also installed the expat and it's dev package")
endif(NOT EXPAT_FOUND)
include_directories(${EXPAT_INCLUDE_DIR})
set (EXPAT_CFLAGS_PKG "-I${EXPAT_INCLUDE_DIRS}")
string(REGEX REPLACE "^(.*)/lib([^/]*)\\.[^.]*$" "-L\\1 -l\\2" EXPAT_LIBS_PKG ${EXPAT_LIBRARY})

if(NOT MKL_FOUND AND NOT GSL_FOUND)
  #explicitly disabled
  file(GLOB VOTCA_LINALG_SOURCES linalg/dummy/*.cc)
elseif (MKL_FOUND)
  include_directories(${MKL_INCLUDE_DIRS})
  file(GLOB VOTCA_LINALG_SOURCES linalg/mkl/*.cc)
  set(LINALG_LIBRARIES ${MKL_LIBRARIES})
elseif(GSL_FOUND)
  include_directories(${GSL_INCLUDE_DIRS})
  file(GLOB VOTCA_LINALG_SOURCES linalg/gsl/*.cc)
  set(LINALG_LIBRARIES ${GSL_LIBRARIES})
endif()

file(GLOB VOTCA_SOURCES *.cc)
file(GLOB NOT_VOTCA_SOURCES version_nb.cc)
file(GLOB_RECURSE VOTCA_SQL_SOURCES database.cc statement.cc)
list(REMOVE_ITEM VOTCA_SOURCES ${NOT_VOTCA_SOURCES} ${VOTCA_SQL_SOURCES})

option(WITH_SQLITE3 "Use SQLite3, at this point only needed for charge transport parts!" ON)
if (WITH_SQLITE3)
  find_package(SQLITE3)
  if(NOT SQLITE3_FOUND)
    message(FATAL_ERROR "SQLITE3 not found,  make sure you have also installed the sqlite3 and it's dev package, at this point sqlite3 is only needed for charge transport parts of VOTCA, so you can just switch it off using -DWITH_SQLITE3=OFF in case you do not need it.")
  endif(NOT SQLITE3_FOUND)
  include_directories(${SQLITE3_INCLUDE_DIRS})
  set(SQLITE3_PKG "sqlite3")
else(WITH_SQLITE3)
  set(SQLITE3_PKG)
  set(VOTCA_SQL_SOURCES)
endif(WITH_SQLITE3)


#for gitversion.h
include_directories(${CMAKE_CURRENT_BINARY_DIR})
add_custom_target(gitversion COMMAND ${CMAKE_COMMAND}
  -DTOP_SOURCE_DIR="${CMAKE_SOURCE_DIR}"
  -DGIT_EXECUTABLE="${GIT_EXECUTABLE}"
  -DMERCURIAL_EXECUTABLE="${MERCURIAL_EXECUTABLE}"
  -P ${CMAKE_MODULE_PATH}/gitversion.cmake)
set_property(DIRECTORY APPEND PROPERTY ADDITIONAL_MAKE_CLEAN_FILES gitversion.h)

add_library(votca_tools ${VOTCA_SOURCES} ${VOTCA_SQL_SOURCES} ${VOTCA_LINALG_SOURCES})
add_dependencies(votca_tools gitversion)
if(MKL_FOUND)
  add_dependencies(votca_tools intel)
endif(MKL_FOUND)
set_target_properties(votca_tools PROPERTIES SOVERSION ${SOVERSION})
target_link_libraries(votca_tools ${Boost_LIBRARIES} ${LINALG_LIBRARIES} ${SQLITE3_LIBRARIES}
  ${FFTW3_LIBRARIES} ${EXPAT_LIBRARIES} ${THREAD_LIBRARIES} ${MATH_LIBRARIES})
install(TARGETS votca_tools LIBRARY DESTINATION ${LIB} ARCHIVE DESTINATION ${LIB})

configure_file(libvotca_tools.pc.in ${CMAKE_CURRENT_BINARY_DIR}/libvotca_tools.pc @ONLY)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/libvotca_tools.pc DESTINATION ${LIB}/pkgconfig)

=== src/tools/CMakeLists.txt ===
foreach(PROG votca_property)
  file(GLOB ${PROG}_SOURCES ${PROG}*.cc)
  add_executable(${PROG} ${${PROG}_SOURCES})
  target_link_libraries(${PROG} votca_tools)
  #not realy useful, re-enable whenever it is ready to replace csg_property
  install(TARGETS ${PROG} RUNTIME DESTINATION bin)

  if (BUILD_MANPAGES)
     add_custom_command(OUTPUT ${PROG}.man
       COMMAND ${CMAKE_CURRENT_BINARY_DIR}/${PROG} --man > ${PROG}.man
       COMMENT "Building ${PROG} manpage"
       DEPENDS ${PROG})
     add_custom_target(${PROG}_manpage DEPENDS ${PROG}.man)
     add_dependencies(manpages ${PROG}_manpage)
     install(FILES ${CMAKE_CURRENT_BINARY_DIR}/${PROG}.man DESTINATION ${MAN}/man1 RENAME ${PROG}.1)
  endif (BUILD_MANPAGES)
endforeach(PROG)

=== include/votca/tools/CMakeLists.txt ===
configure_file(votca_config.h.in ${CMAKE_CURRENT_BINARY_DIR}/votca_config.h)

file(GLOB_RECURSE VOTCA_HEADERS *.h ${CMAKE_CURRENT_BINARY_DIR}/votca_config.h )

if (NOT WITH_SQLITE3)
  file(GLOB_RECURSE NOT_VOTCA_HEADERS database.h statement.h)
  list(REMOVE_ITEM VOTCA_HEADERS ${NOT_VOTCA_HEADERS})
endif(NOT WITH_SQLITE3)
if (NOT GSL_FOUND OR MKL_FOUND)
    file(GLOB_RECURSE NOT_VOTCA_HEADERS votca_gsl_boost_ublas_matrix_prod.h)
    list(REMOVE_ITEM VOTCA_HEADERS ${NOT_VOTCA_HEADERS})
endif (NOT GSL_FOUND OR MKL_FOUND)

       



install(FILES ${VOTCA_HEADERS} DESTINATION include/votca/tools)

=== debian/changelog ===
votca-tools (1.4.1-2) unstable; urgency=medium

  * Add Breaks/Replaces on libvotca-tools3 due to filename conflicts.

 -- Nicholas Breen <nbreen@debian.org>  Thu, 11 Jan 2018 16:18:20 -0800

votca-tools (1.4.1-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.
  * Rename libvotca-tools3 to libvotca-tools4.
  * Bump Standards-Version to 4.1.3, no changes required.

 -- Nicholas Breen <nbreen@debian.org>  Thu, 11 Jan 2018 14:23:15 -0800

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,7 @@
 Source: votca-tools
 Section: libs
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debichem Team <debichem-devel@lists.alioth.debian.org>
+Maintainer: Debichem Team <debichem-devel@lists.alioth.debian.org>
 Uploaders: Christoph Junghans <junghans@votca.org>,
            Michael Banck <mbanck@debian.org>
 Build-Depends: cmake,
@@ -16,7 +15,7 @@
                libsqlite3-dev,
                pkg-config,
                txt2tags
-Standards-Version: 3.9.5
+Standards-Version: 4.1.3
 Homepage: http://www.votca.org
 Vcs-Browser: http://anonscm.debian.org/viewvc/debichem/unstable/votca-tools/
 Vcs-Svn: svn://anonscm.debian.org/debichem/unstable/votca-tools/
@@ -24,7 +23,7 @@
 Package: libvotca-tools-dev
 Section: libdevel
 Architecture: any
-Depends: libvotca-tools3 (= ${binary:Version}), ${misc:Depends}
+Depends: libvotca-tools4 (= ${binary:Version}), ${misc:Depends}
 Description: VOTCA's tools library, development kit
  VOTCA is a software package which focuses on the analysis of molecular
  dynamics data, the development of systematic coarse-graining techniques as
@@ -35,11 +34,11 @@
  .
  This package contains header files and pkg-config files.
 
-Package: libvotca-tools3
+Package: libvotca-tools4
 Architecture: any
 Depends: ${misc:Depends}, ${shlibs:Depends}
-Breaks: libvotca-tools2 (<< 1.3)
-Replaces: libvotca-tools2 (<< 1.3)
+Breaks: libvotca-tools2 (<< 1.3), libvotca-tools3
+Replaces: libvotca-tools2 (<< 1.3), libvotca-tools3
 Description: VOTCA's tools library
  VOTCA is a software package which focuses on the analysis of molecular
  dynamics data, the development of systematic coarse-graining techniques as
